<!doctype html>
<html class="no-js" lang="">
    <head>
        <meta charset="utf-8">
        <meta http-equiv="x-ua-compatible" content="ie=edge">
        <title>gateway documentation</title>
        <meta name="description" content="">
        <meta name="viewport" content="width=device-width, initial-scale=1">

        <link rel="icon" type="image/x-icon" href="../images/favicon.ico">
	      <link rel="stylesheet" href="../styles/style.css">
    </head>
    <body>

        <div class="navbar navbar-default navbar-fixed-top visible-xs">
            <a href="../" class="navbar-brand">gateway documentation</a>
            <button type="button" class="btn btn-default btn-menu ion-ios-menu" id="btn-menu"></button>
        </div>

        <div class="xs-menu menu" id="mobile-menu">
                <div id="book-search-input" role="search"><input type="text" placeholder="Type to search"></div>            <compodoc-menu></compodoc-menu>
        </div>

        <div class="container-fluid main">
           <div class="row main">
               <div class="hidden-xs menu">
                   <compodoc-menu mode="normal"></compodoc-menu>
               </div>
               <!-- START CONTENT -->
               <div class="content class">
                   <div class="content-data">











<ol class="breadcrumb">
  <li>Classes</li>
  <li>CreateUserCommandHandler</li>
</ol>

<ul class="nav nav-tabs" role="tablist">
        <li class="active">
            <a href="#info" role="tab" id="info-tab" data-toggle="tab" data-link="info">Info</a>
        </li>
        <li >
            <a href="#source" role="tab" id="source-tab" data-toggle="tab" data-link="source">Source</a>
        </li>
</ul>

<div class="tab-content">
    <div class="tab-pane fade active in" id="c-info">
        <p class="comment">
            <h3>File</h3>
        </p>
        <p class="comment">
            <code>src/services/users/commands/users.commands.ts</code>
        </p>



            <p class="comment">
                <h3>Implements</h3>
            </p>
            <p class="comment">
                        <code>ICommandHandler</code>
            </p>


            <section>
    <h3 id="index">Index</h3>
    <table class="table table-sm table-bordered index-table">
        <tbody>
                <tr>
                    <td class="col-md-4">
                        <h6><b>Properties</b></h6>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                        <ul class="index-list">
                            <li>
                                    <span class="modifier">Private</span>
                                    <span class="modifier">Readonly</span>
                                <a href="#eventHandle">eventHandle</a>
                            </li>
                            <li>
                                    <span class="modifier">Private</span>
                                    <span class="modifier">Readonly</span>
                                <a href="#logger">logger</a>
                            </li>
                        </ul>
                    </td>
                </tr>

                <tr>
                    <td class="col-md-4">
                        <h6><b>Methods</b></h6>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                        <ul class="index-list">
                            <li>
                                    <span class="modifier">Async</span>
                                <a href="#execute">execute</a>
                            </li>
                        </ul>
                    </td>
                </tr>





        </tbody>
    </table>
</section>

            <section>
    <h3 id="constructor">Constructor</h3>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
<code>constructor(publisher: EventPublisher, eventBus: EventBus)</code>
                    </td>
                </tr>
                        <tr>
                            <td class="col-md-4">
                                <div class="io-line">Defined in <a href="" data-line="50" class="link-to-prism">src/services/users/commands/users.commands.ts:50</a></div>
                            </td>
                        </tr>

                <tr>
                    <td class="col-md-4">
                            <div>
                                    <b>Parameters :</b>
                                    <table class="params">
                                        <thead>
                                            <tr>
                                                <td>Name</td>
                                                    <td>Type</td>
                                                <td>Optional</td>
                                            </tr>
                                        </thead>
                                        <tbody>
                                                <tr>
                                                        <td>publisher</td>
                                                  
                                                        <td>
                                                                    <code>EventPublisher</code>
                                                        </td>
                                                  
                                                    <td>
                                                            No
                                                    </td>
                                                    
                                                </tr>
                                                <tr>
                                                        <td>eventBus</td>
                                                  
                                                        <td>
                                                                    <code>EventBus</code>
                                                        </td>
                                                  
                                                    <td>
                                                            No
                                                    </td>
                                                    
                                                </tr>
                                        </tbody>
                                    </table>
                            </div>
                    </td>
                </tr>
            </tbody>
        </table>
</section>

            <section>
    
        <h3 id="inputs">
            Properties
        </h3>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="eventHandle"></a>
                        <span class="name">
                            <b>
                                <span class="modifier">Private</span>
                                <span class="modifier">Readonly</span>
                            eventHandle</b>
                            <a href="#eventHandle"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                    <tr>
                        <td class="col-md-4">
                            <i>Type : </i>        <code><a href="../classes/UserEventHandle.html" target="_self" >UserEventHandle</a></code>

                        </td>
                    </tr>
                        <tr>
                            <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="50" class="link-to-prism">src/services/users/commands/users.commands.ts:50</a></div>
                            </td>
                        </tr>


            </tbody>
        </table>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="logger"></a>
                        <span class="name">
                            <b>
                                <span class="modifier">Private</span>
                                <span class="modifier">Readonly</span>
                            logger</b>
                            <a href="#logger"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                    <tr>
                        <td class="col-md-4">
                            <i>Default value : </i><code>new Logger(CreateUserCommandHandler.name)</code>
                        </td>
                    </tr>
                        <tr>
                            <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="49" class="link-to-prism">src/services/users/commands/users.commands.ts:49</a></div>
                            </td>
                        </tr>


            </tbody>
        </table>
</section>

            <section>
    
    <h3 id="methods">
        Methods
    </h3>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="execute"></a>
                    <span class="name">
                        <b>
                            <span class="modifier">Async</span>
                            execute
                        </b>
                        <a href="#execute"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
            <tr>
                <td class="col-md-4">
                    <span class="modifier-icon icon ion-ios-reset"></span>
                    <code>execute(command: <a href="../classes/CreateUserCommand.html">CreateUserCommand</a>)</code>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">
                    <div class="io-line">Defined in <a href="" data-line="65"
                            class="link-to-prism">src/services/users/commands/users.commands.ts:65</a></div>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">

                    <div class="io-description">
                        <b>Parameters :</b>
                        <table class="params">
                            <thead>
                                <tr>
                                    <td>Name</td>
                                    <td>Type</td>
                                    <td>Optional</td>
                                </tr>
                            </thead>
                            <tbody>
                                <tr>
                                    <td>command</td>
                                    <td>
                                                <code><a href="../classes/CreateUserCommand.html" target="_self" >CreateUserCommand</a></code>
                                    </td>

                                    <td>
                                        No
                                    </td>


                                </tr>
                            </tbody>
                        </table>
                    </div>
                    <div>
                    </div>
                    <div class="io-description">
                        <b>Returns : </b>    <code>Promise&lt;any&gt;</code>

                    </div>
                    <div class="io-description">
                        
                    </div>
                </td>
            </tr>
        </tbody>
    </table>
</section>





    </div>


    <div class="tab-pane fade  tab-source-code" id="c-source">
        <pre class="line-numbers compodoc-sourcecode"><code class="language-typescript">import { CommandHandler, ICommandHandler, EventPublisher, EventBus, EventsHandler, IEventHandler } from &#x27;@nestjs/cqrs&#x27;
import { Logger } from &#x27;@nestjs/common&#x27;
import { ObjectId } from &#x27;mongodb&#x27;
import * as QRCode from &#x27;qrcode&#x27;
import * as jimp from &#x27;jimp&#x27;
import { UserEventHandle } from &#x27;../events/users.aggregate&#x27;
import { createUserFire, addSocialAccountToUser } from &#x27;./../repositories/user-firebase.repository&#x27;
import { createUserMongo } from &#x27;../repositories/user.repository&#x27;
import { UsersService } from &#x27;../services/users.service&#x27;
import { RoleTypes, INotificationCredential, IUserEntityBase, IUserMongoEntity, IUserFireEntity } from &#x27;../models&#x27;
import { ISocialAccount } from &#x27;../models/social-account&#x27;

export class CreateUserCommand {
    constructor(
        public readonly user_fire_id: string,
        public readonly user_mongo_id: string,
        public readonly username: string,
        public readonly password: string,
        public readonly email: string,
        public readonly account: ISocialAccount,
        public readonly first_name: string,
        public readonly last_name: string,
        public readonly avatar: string,
        public readonly avatar_url: string,
        public readonly private_account: boolean,
        public readonly use_real_name: boolean,
        public readonly roles: RoleTypes[] &#x3D; [],
        public readonly notification_credentials: INotificationCredential[] &#x3D; [],
    ) { }
}

export class AddCustomerIdToUserCommand {
    constructor(
        public readonly mongo_user_id: ObjectId,
        public readonly fire_user_id: string,
        public readonly customer_id: string,
    ) { }
}

export class AddSocialAccountToUserCommand {
    constructor(
        public readonly user_id: string,
        public readonly access_token: string
    ) { }
}

@CommandHandler(CreateUserCommand)
export class CreateUserCommandHandler implements ICommandHandler&lt;CreateUserCommand&gt; {
    private readonly logger &#x3D; new Logger(CreateUserCommandHandler.name)
    private readonly eventHandle: UserEventHandle

    constructor(
        private publisher: EventPublisher,
        private eventBus: EventBus,
    ) {
        // const blueprint &#x3D; publisher.mergeClassContext(BattleEventHandle)
        // this.battleHandle &#x3D; new blueprint()
        // this.battleHandle.autoCommit &#x3D; true
        this.eventHandle &#x3D;
            publisher.mergeObjectContext(
                new UserEventHandle(new ObjectId().toHexString()))
        this.eventHandle.autoCommit &#x3D; true
    }

    async execute(command: CreateUserCommand): Promise&lt;any&gt; {
        this.logger.debug(&#x27;Executing createUserHandler&#x27;)
        try {
            const user_fire_id &#x3D; command.user_fire_id
            const user_mongo_id &#x3D; command.user_mongo_id
            const username &#x3D; command.username
            const password &#x3D; command.password
            const email &#x3D; command.email
            const account &#x3D; command.account
            const first_name &#x3D; command.first_name
            const last_name &#x3D; command.last_name
            const avatar &#x3D; command.avatar
            const avatar_url &#x3D; command.avatar_url
            const private_account &#x3D; command.private_account
            const use_real_name &#x3D; command.use_real_name
            const roles &#x3D; command.roles
            const notification_credentials &#x3D; command.notification_credentials

            if (roles.length &lt;&#x3D; 0) {
                roles.push(RoleTypes.PLEB)
            }

            const baseURL &#x3D; &#x60;roamr/user/${user_mongo_id}&#x60;
            const userURL &#x3D; await QRCode.toDataURL(baseURL, {
                errorCorrectionLevel: &#x27;M&#x27;,
            })

            const base_user: IUserEntityBase &#x3D; {
                customer_id: &#x27;&#x27;,
                social_accounts: [
                    account
                ],
                username: username,
                password: password,
                email: email,
                qr_code: baseURL,
                is_admin: false,
                is_account_verified: false,
                is_verified: false,
                first_name,
                last_name,
                full_name: &#x60;${first_name} ${last_name}&#x60;,
                avatar,
                avatar_url,
                private_account,
                use_real_name,
                roles: roles,
                role_access: [],
                notification_credentials,
            }

            const mongo_user: IUserMongoEntity &#x3D; {
                ...base_user,
                fire_id: user_fire_id,
                _id: new ObjectId(user_mongo_id),
            }

            const fire_user: IUserFireEntity &#x3D; {
                ...base_user,
                fire_id: user_fire_id,
                _id: user_mongo_id,
            }

            await createUserMongo(mongo_user)
            await createUserFire(fire_user)

        } catch (error) {
            this.logger.error(error)
        }
    }
}

@CommandHandler(AddCustomerIdToUserCommand)
export class AddCustomerIdToUserCommandHandler&lt;T extends AddCustomerIdToUserCommand&gt; implements ICommandHandler&lt;T&gt; {
    constructor(
        private readonly usersService: UsersService,
    ) { }

    async execute(command: T) {
        // save/update customer.id to database
        let fire_res &#x3D;
            await this.usersService
                .updateFireUserByValuePair(
                    command.fire_user_id,
                    &#x27;customer_id&#x27;,
                    command.customer_id)

        let mongo_res &#x3D;
            await this.usersService
                .updateMongoUserByValuePair(
                    command.mongo_user_id,
                    &#x27;customer_id&#x27;,
                    command.customer_id)

        return {
            mongo_res,
            fire_res,
        }
    }
}

@CommandHandler(AddSocialAccountToUserCommand)
export class AddSocialAccountToUserCommandHandler&lt;T extends AddSocialAccountToUserCommand&gt;
    implements ICommandHandler&lt;T&gt; {
    private readonly logger &#x3D;
        new Logger(AddSocialAccountToUserCommandHandler.name)
    private readonly eventHandle: UserEventHandle

    constructor(
        private publisher: EventPublisher,
        private eventBus: EventBus,
    ) {
        // const blueprint &#x3D; publisher.mergeClassContext(BattleEventHandle)
        // this.battleHandle &#x3D; new blueprint()
        // this.battleHandle.autoCommit &#x3D; true
        this.eventHandle &#x3D;
            publisher.mergeObjectContext(
                new UserEventHandle(new ObjectId().toHexString()))
        this.eventHandle.autoCommit &#x3D; true
    }

    async execute(command: T): Promise&lt;any&gt; {
        try {
            this.logger.debug(&#x27;AddSocialAccountToUser command&#x27;)

            const user_id &#x3D; command.user_id
            const access_token &#x3D; command.access_token

            this.logger.debug(command)

            await addSocialAccountToUser(
                user_id,
                access_token
            )

        } catch (error) {
            this.logger.error(error)
        }
    }
}</code></pre>
    </div>
</div>



                   




                   </div><div class="search-results">
    <div class="has-results">
        <h1 class="search-results-title"><span class='search-results-count'></span> result-matching "<span class='search-query'></span>"</h1>
        <ul class="search-results-list"></ul>
    </div>
    <div class="no-results">
        <h1 class="search-results-title">No results matching "<span class='search-query'></span>"</h1>
    </div>
</div>
</div>
               <!-- END CONTENT -->
           </div>
       </div>

       <script>
            var COMPODOC_CURRENT_PAGE_DEPTH = 1;
            var COMPODOC_CURRENT_PAGE_CONTEXT = 'class';
            var COMPODOC_CURRENT_PAGE_URL = 'CreateUserCommandHandler.html';
            var MAX_SEARCH_RESULTS = 15;
       </script>

       <script src="../js/libs/custom-elements.min.js"></script>
       <script src="../js/libs/lit-html.js"></script>
       <!-- Required to polyfill modern browsers as code is ES5 for IE... -->
       <script src="../js/libs/custom-elements-es5-adapter.js" charset="utf-8" defer></script>
       <script src="../js/menu-wc.js" defer></script>

       <script src="../js/libs/bootstrap-native.js"></script>

       <script src="../js/libs/es6-shim.min.js"></script>
       <script src="../js/libs/EventDispatcher.js"></script>
       <script src="../js/libs/promise.min.js"></script>
       <script src="../js/libs/zepto.min.js"></script>

       <script src="../js/compodoc.js"></script>

       <script src="../js/tabs.js"></script>
       <script src="../js/menu.js"></script>
       <script src="../js/libs/clipboard.min.js"></script>
       <script src="../js/libs/prism.js"></script>
       <script src="../js/sourceCode.js"></script>
          <script src="../js/search/search.js"></script>
          <script src="../js/search/lunr.min.js"></script>
          <script src="../js/search/search-lunr.js"></script>
          <script src="../js/search/search_index.js"></script>
       <script src="../js/lazy-load-graphs.js"></script>


    </body>
</html>
